"use strict";
/**
 * Copyright (c) 2023, Chamupathi Gigara Hettige. (https://github.com/gigara) All Rights Reserved.
 *
 * Chamupathi Gigara Hettige licenses this file to you under the Apache License,
 * Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GithubActionClient = void 0;
var AbstractCacheProvider_1 = require("./AbstractCacheProvider");
var path_1 = require("path");
var core_1 = require("@actions/core");
var uploadCache_1 = require("./uploadCache");
var downloadCache_1 = require("./downloadCache");
var fs = require('fs');
var BUILD_CACHE_FOLDER = "build-cache";
var GithubActionClient = /** @class */ (function (_super) {
    __extends(GithubActionClient, _super);
    function GithubActionClient() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GithubActionClient.getCache = function (cacheId, cacheRoot) {
        return __awaiter(this, void 0, void 0, function () {
            var ghCacheId, cacheFile, fileExists;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ghCacheId = "".concat(process.platform, "-").concat(cacheId);
                        cacheFile = (0, path_1.join)(cacheRoot, BUILD_CACHE_FOLDER, cacheId);
                        return [4 /*yield*/, (0, downloadCache_1.downloadCache)(cacheFile, ghCacheId)];
                    case 1:
                        _a.sent();
                        fileExists = fs.existsSync(cacheFile);
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                return __awaiter(this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        if (fileExists) {
                                            return [2 /*return*/, resolve(fs.readFileSync(cacheFile))];
                                        }
                                        else {
                                            (0, core_1.notice)("Rush build cache not found with key: ".concat(ghCacheId, "."));
                                            resolve(undefined);
                                        }
                                        return [2 /*return*/];
                                    });
                                });
                            })];
                }
            });
        });
    };
    GithubActionClient.saveCache = function (cacheId, cacheRoot) {
        return __awaiter(this, void 0, void 0, function () {
            var ghCacheId, cacheFile, fileExists, id, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ghCacheId = "".concat(process.platform, "-").concat(cacheId);
                        cacheFile = (0, path_1.join)(cacheRoot, BUILD_CACHE_FOLDER, cacheId);
                        fileExists = fs.existsSync(cacheFile);
                        if (!fileExists) {
                            (0, core_1.error)("Rush build cache not exists with key: ".concat(cacheId, "."));
                            return [2 /*return*/, Promise.reject(new Error("Rush build cache file not exists with key: ".concat(cacheId, ".")))];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, (0, uploadCache_1.uploadCache)(cacheFile, ghCacheId)];
                    case 2:
                        id = _a.sent();
                        return [2 /*return*/, Promise.resolve(true)];
                    case 3:
                        e_1 = _a.sent();
                        (0, core_1.error)("Rush build cache upload failed with key: ".concat(ghCacheId, ". Error: ").concat(e_1));
                        return [2 /*return*/, Promise.reject(new Error("Rush build cache upload failed with key: ".concat(ghCacheId, ". Error: ").concat(e_1)))];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return GithubActionClient;
}(AbstractCacheProvider_1.CacheProvider));
exports.GithubActionClient = GithubActionClient;
